/* Sam Trenholme 2010, 2014 Public domain */

/* This code renames anything that is not [A-Za-z0-9_-\.] or hi-bit
 * in to a file with only [A-Za-z0-9_-].  Hi-bit is allowed to allow
 * UTF-8 filenames (no attempt is made to validate the UTF-8).
 *
 * THIS CODE IS VERY DANGEROUS TO RUN.  It recursively goes through
 * all directories and files from the directory is is run from to
 * rename files with problem characters.
 *
 * USE AT YOUR OWN RISK
 */

#include <sys/types.h>
#include <dirent.h>
#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

char sanechr(char in) {
        if(in >= '0' && in <= '9') {
                return in;
        }
        if(in >= 'A' && in <= 'Z') {
                return in;
        }
        if(in == '.' || in == '_' || in == '-' || in == '/') {
                return in;
        }
        if(in >= 'a' && in <= 'z') {
                return in;
        }
        if(in > 127) { // So UTF-8 can be in filenames
                return in;
        }
        return '_';
}

/* Convert anything in a filename that is not [A-Za-z0-9\-\.] or
 * hi-bit (Unicode) into a _ */
void c_dir(char *path, int depth) {
        DIR *dir;
        struct dirent *rd;
        struct stat stats;
        char sanename[1024];
        int a, max;

        if(depth > 256) {
                return;
        }

        if(chdir(path) != 0) {
                return;
        }
        dir = opendir(".");
        if(dir == NULL) {
                return;
        }

        for(max = 0;max < 131072;max++) {
                rd = readdir(dir);
                if(rd == NULL || rd->d_name == NULL) {
                        return;
                }
                /* Skip "." and ".." */
                if(strlen(rd->d_name) <= 2 && *(rd->d_name) == '.') {
                        if(*(rd->d_name + 1) == 0 ||
                           *(rd->d_name + 1) == '.') {
                                continue;
                        }
                }
                strncpy(sanename,rd->d_name,1023);
                for(a = 0 ; a < 1023 ; a++) {
                        if(*(sanename + a) == 0) {
                                break;
                        }
                        *(sanename + a) = sanechr(*(sanename + a));
                }
                if(lstat(rd->d_name,&stats) != 0) { /* Error */
                        continue;
                }
                // Fixing this so it does not clobber when two or more 
                // filenames map to the same "sane" name is left as an 
                // exercise for the reader
                rename(rd->d_name,sanename);
                if(S_ISDIR(stats.st_mode)) {
                        c_dir(sanename,depth + 1);
                }
        }
        chdir("..");
}

main() {
        c_dir(".",1);
}
